## sigil 2.0.1+dfsg1

=== CMakeLists.txt ===
########################################################
#  
#  This is a CMake configuration file.
#  To use it you need CMake which can be 
#  downloaded from here: 
#    http://www.cmake.org/cmake/resources/software.html
#
#########################################################

cmake_minimum_required( VERSION 3.0 ) 

project( Sigil )

# Need CMAKE 3.18+ to make full use of new FindPython3
# with the Development.Embed submodule.
set( RECENT_CMAKE_VER "3.18.1" )
if ( NOT DEFINED TRY_NEWER_FINDPYTHON3 )
    set ( TRY_NEWER_FINDPYTHON3 0 )
endif()

# Set Inno minimum Windows version 
if ( NOT DEFINED BUILD_FOR_WIN7 )
    # Windows 10 (1809)
    set( BUILD_FOR_WIN7 0 )
    set ( WIN_MIN_VERSION 10.0.17763 )
else()
    # Windows 7sp1
    set ( WIN_MIN_VERSION 6.1.7601 )
endif()

# Default to using Qt5 for builds
# Enable Qt6 with -DUSEQT6=1 in cmake config command
if ( NOT DEFINED USE_QT6 )
    set( USE_QT6 0 )
endif()

if (${CMAKE_VERSION} VERSION_GREATER_EQUAL ${RECENT_CMAKE_VER} AND ${TRY_NEWER_FINDPYTHON3})
    set ( USE_NEWER_FINDPYTHON3 1 )
else()
    set ( USE_NEWER_FINDPYTHON3 0 )
endif()

set( CMAKE_DEBUG_POSTFIX "d" )
# Avoid the whole Release/Debug folder creation with Visual Studio
if (MSVC_IDE)
   set( CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG "${PROJECT_BINARY_DIR}/bin")
   set( CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE "${PROJECT_BINARY_DIR}/bin")
   set( CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG "${PROJECT_BINARY_DIR}/lib")
   set( CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE "${PROJECT_BINARY_DIR}/lib")
   set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG "${PROJECT_BINARY_DIR}/lib")
   set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE "${PROJECT_BINARY_DIR}/lib")
endif()
set( CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin )
set( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib )
set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib )
set( PACKAGE_DIRECTORY ${PROJECT_BINARY_DIR}/package )
set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake_extras" )

set( SIGIL_MAJOR_VERSION 2 )
set( SIGIL_MINOR_VERSION 0 )
set( SIGIL_REVISION_VERSION 1 )
set( SIGIL_FULL_VERSION ${SIGIL_MAJOR_VERSION}.${SIGIL_MINOR_VERSION}.${SIGIL_REVISION_VERSION} )

if( UNIX AND NOT APPLE )
   include(GNUInstallDirs)

   # Make sure the correct rpath is set for the sigil executable
   # on Linux -- for both the build and the installed versions.
   # Needed to make sure the installed shared hunspell and gumbo
   # libraries are found/used at runtime.

   # use, i.e. don't skip the full RPATH for the build tree
   SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

   # when building, don't use the install RPATH already
   # (but later on when installing)
   SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

   SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_FULL_LIBDIR}/sigil")

   # add the automatically determined parts of the RPATH
   # which point to directories outside the build tree to the install RPATH.
   # This will ensure the Qt5 lib directory is always included after install.
   SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

   # Because GCC's link time optimization is willfully choosing to suck.
   add_compile_options(-fno-lto)
endif()

# Check if platform is 64 bit
if( NOT APPLE )
   if( CMAKE_SIZEOF_VOID_P EQUAL 4 )
     set( 64_BIT_PLATFORM 0 )
   else()
     set( 64_BIT_PLATFORM 1 )
   endif()
endif()

# Profiler configuration for GCC
if( CMAKE_COMPILER_IS_GNUCXX  )
    set( CMAKE_BUILD_TYPE profiling )
    set( CMAKE_CXX_FLAGS_PROFILING "-O2 -DNDEBUG -pg -g -fno-omit-frame-pointer -fno-inline-functions -fno-inline-functions-called-once -fno-optimize-sibling-calls" )

    # After creating the new build type,
    # we clear the default back to empty
    set( CMAKE_BUILD_TYPE  )
endif()

if (USE_SYSTEM_LIBS)
    MESSAGE(STATUS "Trying to use System Libraries...")
    find_package( ZLIB )
    find_package( PkgConfig )
    find_package( MiniZip )
    pkg_check_modules( HUNSPELL hunspell )
    if ( NOT APPLE )
        pkg_check_modules( PCRE2 libpcre2-16 )
    endif()
endif()

message(STATUS "CMake version in use: ${CMAKE_VERSION}")

if (${USE_NEWER_FINDPYTHON3})
    message(STATUS "Using newer findpython3 cmake module")
    if ( APPLE )
        find_package(Python3 3.8 COMPONENTS Interpreter Development)
    endif()
    if ( WIN32 )
        find_package(Python3 3.5 COMPONENTS Interpreter Development)
    endif()
    if( UNIX AND NOT APPLE )
        find_package(Python3 3.4 COMPONENTS Interpreter Development)
    endif()
else()
    message(STATUS "Using older findpython cmake module")
    if ( APPLE )
        find_package(PythonInterp 3.8)
        find_package (PythonLibs 3.8)
    endif()
    if ( WIN32 )
        find_package(PythonInterp 3.5)
        find_package (PythonLibs 3.5)
    endif()
    if( UNIX AND NOT APPLE )
        find_package(PythonInterp 3.4)
        find_package (PythonLibs 3.4)
    endif()
endif()

# gumbo-parser it is our main xhtml/html5 parser.
# We have an internal version because it diverges from Google's and GitHub's
# versions and neither want's our epub specific changes.
add_subdirectory( internal/gumbo )

add_subdirectory( 3rdparty/ )
add_subdirectory( src/ )

=== src/CMakeLists.txt ===
########################################################
#
#  This is a CMake configuration file.
#  To use it you need CMake which can be
#  downloaded from here:
#    http://www.cmake.org/cmake/resources/software.html
#
#########################################################


# Print a message and fail for people who don't
# read the build instructions and then complain
# when the build process fails for them.
if ( ${CMAKE_CURRENT_SOURCE_DIR} STREQUAL ${CMAKE_SOURCE_DIR} )
    message( FATAL_ERROR "You are trying to run CMake from the <top_folder>/src/ directory, "
                         "instead of just from the <top_folder> directory.\nDO NOT DO THIS.\n"
                         "The correct way looks like this:\n"
                         "  cmake -G '<generator_name>' /path/to/topmost/folder/in/source/package\n"
                         "You will probably now need to first clean your build directory." )
endif()

# Source File Group Definitions
set( MAIN_FILES
    sigil_constants.h
    sigil_constants.cpp
    sigil_exception.h
    main.cpp
    )

set( BOOK_MANIPULATION_FILES
    BookManipulation/Book.cpp
    BookManipulation/Book.h
    BookManipulation/BookReports.cpp
    BookManipulation/BookReports.h
    BookManipulation/Index.cpp
    BookManipulation/Index.h
    BookManipulation/CleanSource.cpp
    BookManipulation/CleanSource.h
    BookManipulation/FolderKeeper.cpp
    BookManipulation/FolderKeeper.h
    BookManipulation/Headings.cpp
    BookManipulation/Headings.h
    BookManipulation/HTMLMetadata.cpp
    BookManipulation/HTMLMetadata.h
    BookManipulation/XhtmlDoc.cpp
    BookManipulation/XhtmlDoc.h
    )

set( RESOURCE_OBJECT_FILES
    ResourceObjects/Resource.cpp
    ResourceObjects/Resource.h
    ResourceObjects/TextResource.cpp
    ResourceObjects/TextResource.h
    ResourceObjects/HTMLResource.cpp
    ResourceObjects/HTMLResource.h
    ResourceObjects/CSSResource.cpp
    ResourceObjects/CSSResource.h
    ResourceObjects/ImageResource.cpp
    ResourceObjects/ImageResource.h
    ResourceObjects/AudioResource.cpp
    ResourceObjects/AudioResource.h
    ResourceObjects/VideoResource.cpp
    ResourceObjects/VideoResource.h
    ResourceObjects/PdfResource.cpp
    ResourceObjects/PdfResource.h
    ResourceObjects/MiscTextResource.cpp
    ResourceObjects/MiscTextResource.h
    ResourceObjects/SVGResource.cpp
    ResourceObjects/SVGResource.h
    ResourceObjects/FontResource.cpp
    ResourceObjects/FontResource.h
    ResourceObjects/OPFResource.cpp
    ResourceObjects/OPFResource.h
    ResourceObjects/NavProcessor.cpp
    ResourceObjects/NavProcessor.h
    ResourceObjects/NCXResource.cpp
    ResourceObjects/NCXResource.h
    ResourceObjects/XMLResource.cpp
    ResourceObjects/XMLResource.h
    )

set( DIALOG_FILES
    Dialogs/About.cpp
    Dialogs/About.h
    Dialogs/AddSemantics.cpp
    Dialogs/AddSemantics.h
    Dialogs/AddMetadata.cpp
    Dialogs/AddMetadata.h
    Dialogs/ClipboardHistorySelector.h
    Dialogs/ClipboardHistorySelector.cpp
    Dialogs/DeleteFiles.cpp
    Dialogs/DeleteFiles.h
    Dialogs/DeleteStyles.cpp
    Dialogs/DeleteStyles.h
    Dialogs/EditTOC.cpp
    Dialogs/EditTOC.h
    Dialogs/EmptyLayout.cpp
    Dialogs/EmptyLayout.h
    Dialogs/ManageRepos.cpp
    Dialogs/ManageRepos.h
    Dialogs/OpenWithName.cpp
    Dialogs/OpenWithName.h
    Dialogs/RepoLog.cpp
    Dialogs/RepoLog.h
    Dialogs/ChgViewer.cpp
    Dialogs/ChgViewer.h
    Dialogs/SourceViewer.cpp
    Dialogs/SourceViewer.h
    Dialogs/ListSelector.h
    Dialogs/CPCompare.cpp
    Dialogs/CPCompare.h
    Dialogs/RERenamer.cpp
    Dialogs/RERenamer.h
    Dialogs/RETable.cpp
    Dialogs/RETable.h
    Dialogs/SelectCharacter.cpp
    Dialogs/SelectCharacter.h
    Dialogs/SelectCheckpoint.cpp
    Dialogs/SelectCheckpoint.h
    Dialogs/SelectFolder.cpp
    Dialogs/SelectFolder.h
    Dialogs/SelectHyperlink.cpp
    Dialogs/SelectHyperlink.h
    Dialogs/SelectId.cpp
    Dialogs/SelectId.h
    Dialogs/SelectIndexTitle.cpp
    Dialogs/SelectIndexTitle.h
    Dialogs/SelectFiles.cpp
    Dialogs/SelectFiles.h
    Dialogs/AddAutomateTool.cpp
    Dialogs/AddAutomateTool.h
    Dialogs/AddAutomatePlugin.cpp
    Dialogs/AddAutomatePlugin.h
    Dialogs/AutomateEditor.cpp
    Dialogs/AutomateEditor.h
    Dialogs/MetaEditor.cpp
    Dialogs/MetaEditor.h
    Dialogs/TreeItem.cpp
    Dialogs/TreeItem.h
    Dialogs/TreeModel.cpp
    Dialogs/TreeModel.h
    Dialogs/MetaEditorItemDelegate.cpp
    Dialogs/MetaEditorItemDelegate.h
    Dialogs/HeadingSelector.cpp
    Dialogs/HeadingSelector.h
    Dialogs/PluginRunner.cpp
    Dialogs/PluginRunner.h
    Dialogs/Preferences.cpp
    Dialogs/Preferences.h
    Dialogs/PreferenceWidgets/AppearanceWidget.cpp
    Dialogs/PreferenceWidgets/AppearanceWidget.h
    Dialogs/PreferenceWidgets/GeneralSettingsWidget.cpp
    Dialogs/PreferenceWidgets/GeneralSettingsWidget.h
    Dialogs/PreferenceWidgets/KeyboardShortcutsWidget.cpp
    Dialogs/PreferenceWidgets/KeyboardShortcutsWidget.h
    Dialogs/PreferenceWidgets/LanguageWidget.cpp
    Dialogs/PreferenceWidgets/LanguageWidget.h
    Dialogs/PreferenceWidgets/PreferencesWidget.h
    Dialogs/PreferenceWidgets/SpellCheckWidget.cpp
    Dialogs/PreferenceWidgets/SpellCheckWidget.h
    Dialogs/PreferenceWidgets/PreserveEntitiesWidget.cpp
    Dialogs/PreferenceWidgets/PreserveEntitiesWidget.h
    Dialogs/PreferenceWidgets/PluginWidget.cpp
    Dialogs/PreferenceWidgets/PluginWidget.h
    Dialogs/RenameTemplate.cpp
    Dialogs/RenameTemplate.h
    Dialogs/Reports.cpp
    Dialogs/Reports.h
    Dialogs/ReportsWidgets/AllFilesWidget.cpp
    Dialogs/ReportsWidgets/AllFilesWidget.h
    Dialogs/ReportsWidgets/HTMLFilesWidget.cpp
    Dialogs/ReportsWidgets/HTMLFilesWidget.h
    Dialogs/ReportsWidgets/LinksWidget.cpp
    Dialogs/ReportsWidgets/LinksWidget.h
    Dialogs/ReportsWidgets/ImageFilesWidget.cpp
    Dialogs/ReportsWidgets/ImageFilesWidget.h
    Dialogs/ReportsWidgets/CSSFilesWidget.cpp
    Dialogs/ReportsWidgets/CSSFilesWidget.h
    Dialogs/ReportsWidgets/ClassesInHTMLFilesWidget.cpp
    Dialogs/ReportsWidgets/ClassesInHTMLFilesWidget.h
    Dialogs/ReportsWidgets/StylesInCSSFilesWidget.cpp
    Dialogs/ReportsWidgets/StylesInCSSFilesWidget.h
    Dialogs/ReportsWidgets/CharactersInHTMLFilesWidget.cpp
    Dialogs/ReportsWidgets/CharactersInHTMLFilesWidget.h
    Dialogs/ReportsWidgets/ReportsWidget.h
    Dialogs/LinkStylesheets.cpp
    Dialogs/LinkStylesheets.h
    Dialogs/LinkJavascripts.cpp
    Dialogs/LinkJavascripts.h
    Dialogs/SearchEditor.cpp
    Dialogs/SearchEditor.h
    Dialogs/Controls.cpp
    Dialogs/Controls.h
    Dialogs/SearchEditorItemDelegate.cpp
    Dialogs/SearchEditorItemDelegate.h
    Dialogs/CountsReport.cpp
    Dialogs/CountsReport.h
    Dialogs/DryRunReplace.cpp
    Dialogs/DryRunReplace.h
    Dialogs/ReplacementChooser.cpp
    Dialogs/ReplacementChooser.h
    Dialogs/StyledTextDelegate.cpp
    Dialogs/StyledTextDelegate.h
    Dialogs/ClipEditor.cpp
    Dialogs/ClipEditor.h
    Dialogs/IndexEditor.cpp
    Dialogs/IndexEditor.h
    Dialogs/SpellcheckEditor.cpp
    Dialogs/SpellcheckEditor.h
    Dialogs/ViewImage.cpp
    Dialogs/ViewImage.h
    Dialogs/ViewAV.cpp
    Dialogs/ViewAV.h
    Dialogs/ViewFont.cpp
    Dialogs/ViewFont.h
    Dialogs/Inspector.cpp
    Dialogs/Inspector.h
    )

set( WIDGET_FILES
    Widgets/ImageView.cpp
    Widgets/ImageView.h
    Widgets/AVView.cpp
    Widgets/AVView.h
    Widgets/PdfView.cpp
    Widgets/PdfView.h
    Widgets/FontView.cpp
    Widgets/FontView.h
    Widgets/Navigator.h
    Widgets/Navigator2.h
    Widgets/TextView.cpp
    Widgets/TextView.h
    Widgets/TextDocument.h
    Widgets/TextDocument.cpp
    Widgets/TVLineNumberArea.cpp
    Widgets/TVLineNumberArea.h
    )

set( EXPORTER_FILES
    Exporters/ExportEPUB.cpp
    Exporters/ExportEPUB.h
    Exporters/Exporter.h
    Exporters/ExporterFactory.cpp
    Exporters/ExporterFactory.h
    Exporters/NCXWriter.cpp
    Exporters/NCXWriter.h
    Exporters/XMLWriter.cpp
    Exporters/XMLWriter.h
    Exporters/EncryptionXmlWriter.cpp
    Exporters/EncryptionXmlWriter.h
    )

set( IMPORTER_FILES
    Importers/ImportEPUB.cpp
    Importers/ImportEPUB.h
    Importers/Importer.cpp
    Importers/Importer.h
    Importers/ImporterFactory.cpp
    Importers/ImporterFactory.h
    Importers/ImportHTML.cpp
    Importers/ImportHTML.h
    Importers/ImportTXT.cpp
    Importers/ImportTXT.h
    )

set ( QUERY_FILES
    Query/CNode.cpp
    Query/CNode.h
    Query/CObject.cpp
    Query/CObject.h
    Query/CParser.cpp
    Query/CParser.h
    Query/CQueryUtil.cpp
    Query/CQueryUtil.h
    Query/CSelection.cpp
    Query/CSelection.h
    Query/CSelector.cpp
    Query/CSelector.h
    )


set( PARSERS_FILES
    Parsers/CSSInfo.cpp
    Parsers/CSSInfo.h
    Parsers/CSSToolbox.cpp
    Parsers/CSSToolbox.h
    Parsers/HTMLStyleInfo.cpp
    Parsers/HTMLStyleInfo.h
    Parsers/qCSSParser.cpp
    Parsers/qCSSParser.h
    Parsers/qCSSUtils.cpp
    Parsers/qCSSUtils.h
    Parsers/qCSSProperties.cpp
    Parsers/qCSSProperties.h
    Parsers/GumboInterface.h
    Parsers/GumboInterface.cpp
    Parsers/TagAtts.cpp
    Parsers/TagAtts.h
    Parsers/QuickParser.cpp
    Parsers/QuickParser.h
    Parsers/TagLister.cpp
    Parsers/TagLister.h
    Parsers/OPFParser.cpp
    Parsers/OPFParser.h
   )

set( EMBEDPYTHON_FILES
    EmbedPython/DiffRec.h
    EmbedPython/PyObjectPtr.h
    EmbedPython/PyObjectPtr.cpp
    EmbedPython/EmbeddedPython.h
    EmbedPython/EmbeddedPython.cpp
    EmbedPython/PythonRoutines.h
    EmbedPython/PythonRoutines.cpp
    )

set( MISC_FILES
    Misc/AppEventFilter.cpp
    Misc/AppEventFilter.h
    Misc/AsciiFy.cpp
    Misc/AsciiFy.h
    Misc/UpdateChecker.cpp
    Misc/UpdateChecker.h
    Misc/URLInterceptor.cpp
    Misc/URLInterceptor.h
    Misc/URLSchemeHandler.cpp
    Misc/URLSchemeHandler.h
    Misc/Utility.cpp
    Misc/Utility.h
    Misc/SleepFunctions.h
    Misc/FindReplaceQLineEdit.cpp
    Misc/FindReplaceQLineEdit.h
    Misc/FilenameDelegate.cpp
    Misc/FilenameDelegate.h
    Misc/XHTMLHighlighter.cpp
    Misc/XHTMLHighlighter.h
    Misc/XHTMLHighlighter2.cpp
    Misc/XHTMLHighlighter2.h
    Misc/CSSHighlighter.cpp
    Misc/CSSHighlighter.h
    Misc/HTMLEncodingResolver.cpp
    Misc/HTMLEncodingResolver.h
    Misc/HTMLSpellCheck.cpp
    Misc/HTMLSpellCheck.h
    Misc/HTMLSpellCheckML.cpp
    Misc/HTMLSpellCheckML.h
    Misc/PasteTargetComboBox.cpp
    Misc/PasteTargetComboBox.h
    Misc/PasteTarget.h
    Misc/Plugin.cpp
    Misc/Plugin.h
    Misc/PluginDB.cpp
    Misc/PluginDB.h
    Misc/QCodePage437Codec.cpp
    Misc/QCodePage437Codec.h
    Misc/SearchOperations.cpp
    Misc/SearchOperations.h
    Misc/SigilDarkStyle.cpp
    Misc/SigilDarkStyle.h
    Misc/Language.cpp
    Misc/Language.h
    Misc/DescriptiveInfo.h
    Misc/GuideItems.h
    Misc/GuideItems.cpp
    Misc/Landmarks.h
    Misc/Landmarks.cpp
    Misc/MarcRelators.cpp
    Misc/MarcRelators.h
    Misc/UILanguage.cpp
    Misc/UILanguage.h
    Misc/SettingsStore.cpp
    Misc/SettingsStore.h
    Misc/SpellCheck.cpp
    Misc/SpellCheck.h
    Misc/KeyboardShortcut.cpp
    Misc/KeyboardShortcut.h
    Misc/KeyboardShortcut_p.h
    Misc/KeyboardShortcutManager.cpp
    Misc/KeyboardShortcutManager.h
    Misc/XhtmlEntitiesDtd.cpp
    Misc/Ncx20051Dtd.cpp
    Misc/FontObfuscation.cpp
    Misc/FontObfuscation.h
    Misc/TempFolder.cpp
    Misc/TempFolder.h
    Misc/OpenExternally.cpp
    Misc/OpenExternally.h
    Misc/TOCHTMLWriter.cpp
    Misc/TOCHTMLWriter.h
    Misc/NumericItem.h
    Misc/LocaleAwareItem.h
    Misc/ValidationResult.h
    Misc/ValidationResult.cpp
    Misc/WrapIndicator.h
    Misc/XMLEntities.cpp
    Misc/XMLEntities.h
    Misc/MediaTypes.cpp
    Misc/MediaTypes.h
    Misc/WebProfileMgr.cpp
    Misc/WebProfileMgr.h
    Misc/webviewprinter.cpp
    Misc/webviewprinter.h
    )

set( MISC_EDITORS_FILES
    MiscEditors/ClipEditorModel.cpp
    MiscEditors/ClipEditorModel.h
    MiscEditors/ClipEditorTreeView.cpp
    MiscEditors/ClipEditorTreeView.h

=== internal/gumbo/CMakeLists.txt ===
########################################################
#  
#  This is a CMake configuration file.
#  To use it you need CMake which can be 
#  downloaded from here: 
#    http://www.cmake.org/cmake/resources/software.html
#
#########################################################

cmake_minimum_required( VERSION 3.0 ) 

project( sigilgumbo C )

set( GUMBO_LIBRARIES ${PROJECT_NAME} CACHE INTERNAL "" )
set( GUMBO_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "" )

file( GLOB SOURCES *.c )
list( SORT SOURCES )

if( APPLE )
        set(CMAKE_MACOSX_RPATH 1)
endif()

if ( MSVC )
     set( SOURCES ${SOURCES} include/gumbo_windll.def)
endif()

add_library( sigilgumbo SHARED ${SOURCES} ) 

# Special compiler and linker flags for MSVC
if( MSVC )
    set ( EXTRA_INC include/ )
    include_directories( SYSTEM ${EXTRA_INC} )
    add_definitions( -Dinline=__inline )

    set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /MP")
    set( CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /Oi /GL" )
    set( CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS} /LTCG" )
endif()

if( UNIX AND NOT APPLE )
	set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99" )
endif()

=== debian/changelog ===
sigil (2.0.1+dfsg1-1build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:59:40 +1100

sigil (2.0.1+dfsg1-1build3) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 07:05:38 +0000

sigil (2.0.1+dfsg1-1build2) noble; urgency=medium

  * No-change rebuild for python3.12 t64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 02 Mar 2024 21:15:24 +0100

sigil (2.0.1+dfsg1-1build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 19 Jan 2024 20:54:51 +0000

sigil (2.0.1+dfsg1-1) unstable; urgency=medium

  * New upstream version 2.0.1+dfsg1.
    + https://sigil-ebook.com/blog/sigil-2.0.0-released/
    + https://sigil-ebook.com/blog/sigil-2.0.1-released/
    + https://github.com/Sigil-Ebook/Sigil/releases/tag/1.9.30
    + https://github.com/Sigil-Ebook/Sigil/releases/tag/2.0.0
    + https://github.com/Sigil-Ebook/Sigil/releases/tag/2.0.1
  * Update watchfile to use tags instead of releases in github.
  * Refresh th eupstream signing key that was expired,
  * Drop patch applied upstream.
  * d/rules: update path to the embedded jquery.
  * Repack to remove the docs/ directory that does not contain anything useful
    for us and just triggers lintian.
  * Update copyright.
  * Adjust lintian override syntax

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 04 Sep 2023 14:09:34 +0530

=== debian/control ===
Source: sigil
Section: editors
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Mattia Rizzolo <mattia@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-sequence-python3,
 libhunspell-dev,
 libjs-jquery,
 libjs-jquery-scrollto,
 libminizip-dev,
 libpcre2-dev,
 pkg-config,
 python3-dev,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 qtwebengine5-dev,
 zlib1g-dev,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://sigil-ebook.com
Vcs-Git: https://salsa.debian.org/debian/sigil.git
Vcs-Browser: https://salsa.debian.org/debian/sigil

Package: sigil
Architecture: any
Depends:
 libhunspell-dev,
 libjs-jquery-scrollto,
 python3-dulwich,
 python3-lxml,
 sigil-data (<< ${source:Version}+),
 sigil-data (>= ${source:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 python3,
 python3-chardet,
 python3-css-parser,
 python3-cssselect,
 python3-cssutils,
 python3-html5lib,
 python3-pil,
 python3-pyqt5,
 python3-pyqtwebengine,
 python3-regex,
 python3-six,
Suggests:
 pageedit,
Description: multi-platform ebook editor
 Sigil is a free, open source, multi-platform ebook editor.
 It is designed to edit books in ePub format.
 .
 Features:
 .
  * Full UTF-16 support;
  * Full EPUB 2 spec support;
  * Multiple Views: Book View, Code View and Preview View;
  * WYSIWYG editing in Book View;
  * Complete control over directly editing EPUB syntax in Code View;
  * Table of Contents generator with multi-level heading support;
  * Metadata editor with full support for all possible metadata entries (more
    than 200) with full descriptions for each;
  * User interface translated into many languages;
  * Spell checking with default and user configurable dictionaries;
  * Full Regular Expression (PCRE) support for Find & Replace;
  * Supports import of EPUB and HTML files, images, and style sheets;
  * Files can be validated for EPUB compliance with the FlightCrew validator;
  * HTML Tidy: all imported files have their formatting corrected, and your
    editing can be optionally cleaned.

Package: sigil-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 sigil (= ${source:Version}),
Description: multi-platform ebook editor - data files
 Sigil is a free, open source, multi-platform ebook editor.
 It is designed to edit books in ePub format.
 .
 Features:
 .
  * Full UTF-16 support;
  * Full EPUB 2 spec support;
  * Multiple Views: Book View, Code View and Preview View;
  * WYSIWYG editing in Book View;
  * Complete control over directly editing EPUB syntax in Code View;
  * Table of Contents generator with multi-level heading support;
  * Metadata editor with full support for all possible metadata entries (more
    than 200) with full descriptions for each;
  * User interface translated into many languages;
  * Spell checking with default and user configurable dictionaries;
  * Full Regular Expression (PCRE) support for Find & Replace;
  * Supports import of EPUB and HTML files, images, and style sheets;
  * Files can be validated for EPUB compliance with the FlightCrew validator;
  * HTML Tidy: all imported files have their formatting corrected, and your
    editing can be optionally cleaned.
 .
 This package provides the architecture-independant files.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	ln -svf /usr/share/javascript/jquery/jquery.min.js $(CURDIR)/src/Resource_Files/javascript/jquery-3.6.4.min.js
	ln -svf /usr/share/javascript/jquery-scrollto/jquery.scrollTo.min.js $(CURDIR)/src/Resource_Files/javascript/jquery.scrollTo-2.1.2-min.js
	dh_auto_configure -- \
		-DUSE_SYSTEM_LIBS=1 \
		-DDISABLE_UPDATE_CHECK=1 \
		-DSYSTEM_LIBS_REQUIRED=1 \
		-DINSTALL_BUNDLED_DICTS=0 \
		-DINSTALL_HICOLOR_ICONS=1 \

execute_before_dh_install:
	rm -v $(CURDIR)/debian/tmp/usr/share/sigil/plugin_launchers/python/sigil_bs4/COPYING.txt

override_dh_python3:
	dh_python3 --no-ext-rename

## sigil 2.2.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,8 @@
 #
 #########################################################
 
-cmake_minimum_required( VERSION 3.0 ) 
+# Hard minimum version of cmake for all sub projects and Sigil
+cmake_minimum_required( VERSION 3.5 ) 
 
 project( Sigil )
 
@@ -28,10 +29,10 @@
     set ( WIN_MIN_VERSION 6.1.7601 )
 endif()
 
-# Default to using Qt5 for builds
-# Enable Qt6 with -DUSEQT6=1 in cmake config command
-if ( NOT DEFINED USE_QT6 )
-    set( USE_QT6 0 )
+# Default to using Qt6 for builds
+# Enable Qt5 with -DUSE_QT5=1 in cmake config command
+if ( NOT DEFINED USE_QT5 )
+    set( USE_QT5 0 )
 endif()
 
 if (${CMAKE_VERSION} VERSION_GREATER_EQUAL ${RECENT_CMAKE_VER} AND ${TRY_NEWER_FINDPYTHON3})
@@ -57,7 +58,7 @@
 set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake_extras" )
 
 set( SIGIL_MAJOR_VERSION 2 )
-set( SIGIL_MINOR_VERSION 0 )
+set( SIGIL_MINOR_VERSION 2 )
 set( SIGIL_REVISION_VERSION 1 )
 set( SIGIL_FULL_VERSION ${SIGIL_MAJOR_VERSION}.${SIGIL_MINOR_VERSION}.${SIGIL_REVISION_VERSION} )

=== debian/changelog ===
sigil (2.2.1+dfsg-1) unstable; urgency=medium

  [ Alexandre Detiste ]
  * python3-six is deprecated and being slowly removed.  Closes: #1069014

  [ Mattia Rizzolo ]
  * New upstream version 2.2.1+dfsg.
    https://sigil-ebook.com/blog/sigil-2.0.2-released/
    https://sigil-ebook.com/blog/sigil-2.1.0-released/
    https://sigil-ebook.com/blog/sigil-2.2.0-released/
    https://sigil-ebook.com/blog/sigil-2.2.1-released/
    + Support Python 3.12.  Closes: #1064992
  * Update copyright.
  * Build sigil with Qt6.
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Mattia Rizzolo <mattia@debian.org>  Sun, 28 Jul 2024 10:45:08 +0900

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: sigil
 Section: editors
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Mattia Rizzolo <mattia@debian.org>
+Maintainer: Mattia Rizzolo <mattia@debian.org>
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
@@ -14,12 +13,13 @@
  libpcre2-dev,
  pkg-config,
  python3-dev,
- qtbase5-dev,
- qttools5-dev,
- qttools5-dev-tools,
- qtwebengine5-dev,
+ qt6-5compat-dev,
+ qt6-base-dev,
+ qt6-svg-dev,
+ qt6-tools-dev,
+ qt6-webengine-dev,
  zlib1g-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://sigil-ebook.com
 Vcs-Git: https://salsa.debian.org/debian/sigil.git
@@ -48,7 +48,6 @@
  python3-pyqt5,
  python3-pyqtwebengine,
  python3-regex,
- python3-six,
 Suggests:
  pageedit,
 Description: multi-platform ebook editor

## sigil 2.3.1%2Bdfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -29,12 +29,6 @@
     set ( WIN_MIN_VERSION 6.1.7601 )
 endif()
 
-# Default to using Qt6 for builds
-# Enable Qt5 with -DUSE_QT5=1 in cmake config command
-if ( NOT DEFINED USE_QT5 )
-    set( USE_QT5 0 )
-endif()
-
 if (${CMAKE_VERSION} VERSION_GREATER_EQUAL ${RECENT_CMAKE_VER} AND ${TRY_NEWER_FINDPYTHON3})
     set ( USE_NEWER_FINDPYTHON3 1 )
 else()
@@ -58,7 +52,7 @@
 set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake_extras" )
 
 set( SIGIL_MAJOR_VERSION 2 )
-set( SIGIL_MINOR_VERSION 2 )
+set( SIGIL_MINOR_VERSION 3 )
 set( SIGIL_REVISION_VERSION 1 )
 set( SIGIL_FULL_VERSION ${SIGIL_MAJOR_VERSION}.${SIGIL_MINOR_VERSION}.${SIGIL_REVISION_VERSION} )

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -234,6 +234,8 @@
     Widgets/TextDocument.cpp
     Widgets/TVLineNumberArea.cpp
     Widgets/TVLineNumberArea.h
+    Widgets/CaretStyle.cpp
+    Widgets/CaretStyle.h
     )
 
 set( EXPORTER_FILES
@@ -351,8 +353,6 @@
     Misc/Plugin.h
     Misc/PluginDB.cpp
     Misc/PluginDB.h
-    Misc/QCodePage437Codec.cpp
-    Misc/QCodePage437Codec.h
     Misc/SearchOperations.cpp
     Misc/SearchOperations.h
     Misc/SigilDarkStyle.cpp
@@ -407,3 +407,4 @@
     MiscEditors/ClipEditorModel.h
     MiscEditors/ClipEditorTreeView.cpp
     MiscEditors/ClipEditorTreeView.h
+    MiscEditors/IndexEditorModel.cpp

=== internal/gumbo/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 #
 #########################################################
 
-cmake_minimum_required( VERSION 3.0 ) 
+cmake_minimum_required( VERSION 3.5 ) 
 
 project( sigilgumbo C )

## sigil 2.3.1+dfsg

=== debian/changelog ===
sigil (2.3.1+dfsg-0.1~mx23+1) mx; urgency=medium

  * New upstream version 2.3.1+dfsg.
  * Remove the no longer supported qt6-5compat-dev.
  * Add preferred alternative python3-pyqt6 dependency.
  * Restore python3-six as dependency, and make recommended depends explicit.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 01 Jan 2025 20:18:21 -0800

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,23 @@
 Source: sigil
 Section: editors
 Priority: optional
-Maintainer: Mattia Rizzolo <mattia@debian.org>
-Build-Depends:
- cmake,
- debhelper-compat (= 13),
- dh-sequence-python3,
- libhunspell-dev,
- libjs-jquery,
- libjs-jquery-scrollto,
- libminizip-dev,
- libpcre2-dev,
- pkg-config,
- python3-dev,
- qt6-5compat-dev,
- qt6-base-dev,
- qt6-svg-dev,
- qt6-tools-dev,
- qt6-webengine-dev,
- zlib1g-dev,
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Mattia Rizzolo <mattia@debian.org>
+Build-Depends: cmake,
+               debhelper-compat (= 13),
+               dh-sequence-python3,
+               libhunspell-dev,
+               libjs-jquery,
+               libjs-jquery-scrollto,
+               libminizip-dev,
+               libpcre2-dev,
+               pkg-config,
+               python3-dev,
+               qt6-base-dev,
+               qt6-svg-dev,
+               qt6-tools-dev,
+               qt6-webengine-dev,
+               zlib1g-dev
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://sigil-ebook.com
@@ -27,29 +26,27 @@
 
 Package: sigil
 Architecture: any
-Depends:
- libhunspell-dev,
- libjs-jquery-scrollto,
- python3-dulwich,
- python3-lxml,
- sigil-data (<< ${source:Version}+),
- sigil-data (>= ${source:Version}),
- ${misc:Depends},
- ${python3:Depends},
- ${shlibs:Depends},
-Recommends:
- python3,
- python3-chardet,
- python3-css-parser,
- python3-cssselect,
- python3-cssutils,
- python3-html5lib,
- python3-pil,
- python3-pyqt5,
- python3-pyqtwebengine,
- python3-regex,
-Suggests:
- pageedit,
+Depends: libhunspell-dev,
+         libjs-jquery-scrollto,
+         python3-dulwich,
+         python3-lxml,
+         sigil-data (<< ${source:Version}+),
+         sigil-data (>= ${source:Version}),
+         ${misc:Depends},
+         ${python3:Depends},
+         ${shlibs:Depends},
+         python3-six,
+            python3,
+            python3-chardet,
+            python3-css-parser,
+            python3-cssselect,
+            python3-cssutils,
+            python3-html5lib,
+            python3-pil,
+            python3-pyqt6,
+#            python3-pyqtwebengine,
+            python3-regex
+Suggests: pageedit
 Description: multi-platform ebook editor
  Sigil is a free, open source, multi-platform ebook editor.
  It is designed to edit books in ePub format.
@@ -75,10 +72,8 @@
 Package: sigil-data
 Architecture: all
 Multi-Arch: foreign
-Depends:
- ${misc:Depends},
-Recommends:
- sigil (= ${source:Version}),
+Depends: ${misc:Depends}
+Recommends: sigil (= ${source:Version})
 Description: multi-platform ebook editor - data files
  Sigil is a free, open source, multi-platform ebook editor.
  It is designed to edit books in ePub format.
@@ -101,4 +96,4 @@
   * HTML Tidy: all imported files have their formatting corrected, and your
     editing can be optionally cleaned.
  .
- This package provides the architecture-independant files.
+ This package provides the architecture-independent files.

=== debian/rules ===
--- 
+++ 
@@ -21,3 +21,8 @@
 
 override_dh_python3:
 	dh_python3 --no-ext-rename
+
+# No dbgsym packages:
+override_dh_strip:
+	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
+	dh_strip --no-automatic-dbgsym

## sigil 2.4.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,15 +8,39 @@
 #########################################################
 
 # Hard minimum version of cmake for all sub projects and Sigil
-cmake_minimum_required( VERSION 3.5 ) 
+cmake_minimum_required( VERSION 3.18 ) 
 
 project( Sigil )
 
-# Need CMAKE 3.18+ to make full use of new FindPython3
-# with the Development.Embed submodule.
-set( RECENT_CMAKE_VER "3.18.1" )
+# Change this URL if the location of the CI Windows Qt6 download ever changes
+set (WINQTURL "https://github.com/dougmassay/win-qtwebkit-5.212/releases/download/v5.212-1")
+
+# Used to keep downloaded Qt and PySide6 versions in sync.
+# Check https://github.com/dougmassay/win-qtwebkit-5.212/releases/ to
+# see what versions are available. Defaults to 6.7.3.
+if(NOT DEFINED QTVER)
+    set(QTVER 6.7.3)
+endif()
+
+# Default to using newe findPython3 on Windows and Linux
 if ( NOT DEFINED TRY_NEWER_FINDPYTHON3 )
-    set ( TRY_NEWER_FINDPYTHON3 0 )
+    if ( NOT APPLE )
+        set ( TRY_NEWER_FINDPYTHON3 1 )
+    else()
+        set ( TRY_NEWER_FINDPYTHON3 0 )
+    endif()
+endif()
+
+# Set to 1 to create and use a virtual Python venv on Windows and Linux.
+# Use in conjunction with QTVER to download/install correct PySide6 module
+if ( NOT DEFINED USE_VIRT_PY )
+    set ( USE_VERT_PY 0 )
+endif()
+
+# Set to 1 to download and use a custom-built Qt from WINQTURL.
+# Use in conjunction with QTVER to clarify which version of Qt to download.
+if ( NOT DEFINED DOWNLOAD_QT )
+    set ( DOWNLOAD_QT 0 )
 endif()
 
 # Set Inno minimum Windows version 
@@ -29,7 +53,7 @@
     set ( WIN_MIN_VERSION 6.1.7601 )
 endif()
 
-if (${CMAKE_VERSION} VERSION_GREATER_EQUAL ${RECENT_CMAKE_VER} AND ${TRY_NEWER_FINDPYTHON3})
+if (TRY_NEWER_FINDPYTHON3)
     set ( USE_NEWER_FINDPYTHON3 1 )
 else()
     set ( USE_NEWER_FINDPYTHON3 0 )
@@ -40,10 +64,13 @@
 if (MSVC_IDE)
    set( CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG "${PROJECT_BINARY_DIR}/bin")
    set( CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE "${PROJECT_BINARY_DIR}/bin")
+   set( CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO "${PROJECT_BINARY_DIR}/bin")
    set( CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG "${PROJECT_BINARY_DIR}/lib")
    set( CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE "${PROJECT_BINARY_DIR}/lib")
+   set( CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELWITHDEBINFO "${PROJECT_BINARY_DIR}/lib")
    set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG "${PROJECT_BINARY_DIR}/lib")
    set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE "${PROJECT_BINARY_DIR}/lib")
+   set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELWITHDEBINFO "${PROJECT_BINARY_DIR}/lib")
 endif()
 set( CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin )
 set( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib )
@@ -52,8 +79,8 @@
 set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake_extras" )
 
 set( SIGIL_MAJOR_VERSION 2 )
-set( SIGIL_MINOR_VERSION 3 )
-set( SIGIL_REVISION_VERSION 1 )
+set( SIGIL_MINOR_VERSION 4 )
+set( SIGIL_REVISION_VERSION 2 )
 set( SIGIL_FULL_VERSION ${SIGIL_MAJOR_VERSION}.${SIGIL_MINOR_VERSION}.${SIGIL_REVISION_VERSION} )
 
 if( UNIX AND NOT APPLE )
@@ -117,27 +144,53 @@
 if (${USE_NEWER_FINDPYTHON3})
     message(STATUS "Using newer findpython3 cmake module")
     if ( APPLE )
-        find_package(Python3 3.8 COMPONENTS Interpreter Development)
+        find_package(Python3 3.9 COMPONENTS Interpreter Development)
     endif()
     if ( WIN32 )
-        find_package(Python3 3.5 COMPONENTS Interpreter Development)
+        if ( DOWNLOAD_QT )
+            include(windownloadqt.cmake)
+            set(CMAKE_PREFIX_PATH "${CMAKE_CURRENT_BINARY_DIR}/Qt${QTVER}/lib/cmake")
+            set(Qt6_Dir "${CMAKE_CURRENT_BINARY_DIR}/Qt${QTVER}/lib/cmake/Qt6")
+            if(NOT EXISTS "${Qt6_Dir}")
+                message(FATAL_ERROR "Qt6 download/configure unsuccessful!")
+            endif()
+        endif()
+        if ( USE_VIRT_PY )
+            include(winvirtpy.cmake)
+            # Set hints so virtual Python environement is found first
+            set(Python3_FIND_VIRTUAL ONLY)
+            set(Python3_FIND_REGISTRY NEVER)
+            set(Python3_FIND_STRATEGY LOCATION)
+            # Trick cmake's findPython3 module into thinking the virtual python is activated
+            set(VIRT_PATH "${CMAKE_CURRENT_BINARY_DIR}/sigilpy")
+            set(ENV{VIRTUAL_ENV} "${VIRT_PATH}")
+            if(NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/sigilpy/Scripts/python.exe")
+                message(FATAL_ERROR "Virtual Python setup unsuccessful!")
+            endif()
+        endif()
+        find_package(Python3 3.9 REQUIRED COMPONENTS Interpreter Development)
     endif()
     if( UNIX AND NOT APPLE )
-        find_package(Python3 3.4 COMPONENTS Interpreter Development)
+        if ( USE_VIRT_PY )
+            # Must be run in an environment with the venv activated
+            set ( Python3_FIND_VIRTUAL ONLY )
+            add_definitions( -DLINUX_VIRT_PY )
+        endif()
+        find_package(Python3 3.9 COMPONENTS Interpreter Development)
     endif()
 else()
     message(STATUS "Using older findpython cmake module")
     if ( APPLE )
-        find_package(PythonInterp 3.8)
-        find_package (PythonLibs 3.8)
+        find_package(PythonInterp 3.11)
+        find_package (PythonLibs 3.11)
     endif()
     if ( WIN32 )
-        find_package(PythonInterp 3.5)
-        find_package (PythonLibs 3.5)
+        find_package(PythonInterp 3.9)
+        find_package (PythonLibs 3.9)
     endif()
     if( UNIX AND NOT APPLE )
-        find_package(PythonInterp 3.4)
-        find_package (PythonLibs 3.4)
+        find_package(PythonInterp 3.9)
+        find_package (PythonLibs 3.9)
     endif()
 endif()

=== 3rdparty/CMakeLists.txt ===
project(3rdparty)

# Note: All files in the cmake dir will be included as if they were in this file.
#       The paths in each .cmake file are relative to this directory not the
#       cmake directory.

IF(MSVC)
    add_definitions( /D_CRT_SECURE_NO_WARNINGS /DUNICODE /D_UNICODE )
ENDIF()

if( NOT USE_SYSTEM_LIBS OR NOT ZLIB_FOUND )
    MESSAGE(STATUS "Using Bundled ZLIB")
    include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/zlib.cmake)
else ()
    MESSAGE(STATUS "Using System ZLIB")
endif()

if( NOT USE_SYSTEM_LIBS OR NOT MINIZIP_FOUND )
    MESSAGE(STATUS "Using Bundled MiniZip")
    include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/minizip.cmake)
else ()
    MESSAGE(STATUS "Using System MiniZip")
endif()

if( NOT USE_SYSTEM_LIBS OR NOT HUNSPELL_FOUND )
    MESSAGE(STATUS "Using Bundled Hunspell")
    include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/hunspell.cmake)
else ()
    MESSAGE(STATUS "Using System Hunspell")
endif()

if( NOT USE_SYSTEM_LIBS OR NOT PCRE2_FOUND OR APPLE )
    MESSAGE(STATUS "Using Bundled PCRE2")
    include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/pcre2.cmake)
else ()
    MESSAGE(STATUS "Using System PCRE2")
endif()

if (SYSTEM_LIBS_REQUIRED)
    if (NOT ZLIB_FOUND OR NOT MINIZIP_FOUND OR NOT HUNSPELL_FOUND OR (NOT APPLE AND NOT PCRE2_FOUND))
        #if (NOT ZLIB_FOUND OR NOT MINIZIP_FOUND OR (NOT APPLE AND NOT PCRE2_FOUND))
        MESSAGE(FATAL_ERROR "Could not find all required system libraries...")
    endif()
endif()

if( (UNIX AND NOT APPLE) AND BUILD_PATCHED_LIBXML2 )
      include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/ext_libxml2.cmake)
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -98,6 +98,8 @@
     Dialogs/EmptyLayout.h
     Dialogs/ManageRepos.cpp
     Dialogs/ManageRepos.h
+    Dialogs/MDViewer.cpp
+    Dialogs/MDViewer.h
     Dialogs/OpenWithName.cpp
     Dialogs/OpenWithName.h
     Dialogs/RepoLog.cpp
@@ -127,6 +129,8 @@
     Dialogs/SelectIndexTitle.h
     Dialogs/SelectFiles.cpp
     Dialogs/SelectFiles.h
+    Dialogs/SemanticTargetID.cpp
+    Dialogs/SemanticTargetID.h
     Dialogs/AddAutomateTool.cpp
     Dialogs/AddAutomateTool.h
     Dialogs/AddAutomatePlugin.cpp
@@ -405,6 +409,3 @@
 set( MISC_EDITORS_FILES
     MiscEditors/ClipEditorModel.cpp
     MiscEditors/ClipEditorModel.h
-    MiscEditors/ClipEditorTreeView.cpp
-    MiscEditors/ClipEditorTreeView.h
-    MiscEditors/IndexEditorModel.cpp

=== internal/gumbo/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 #
 #########################################################
 
-cmake_minimum_required( VERSION 3.5 ) 
+cmake_minimum_required( VERSION 3.18 ) 
 
 project( sigilgumbo C )

=== debian/changelog ===
sigil (2.4.2+dfsg-1) unstable; urgency=medium

  * New upstream version 2.4.2+dfsg.
    https://sigil-ebook.com/blog/sigil-2.3.0-released/
    https://sigil-ebook.com/blog/sigil-2.3.1-released/
    https://sigil-ebook.com/blog/sigil-2.4.0-released/
    https://sigil-ebook.com/blog/sigil-2.4.2-released/
    + Fix build with Qt 6.8.  Closes: #1100318
  * Update copyright.
  * Bump Standards-Version to 4.7.2, no changes needed.
  * New dependencies: libcups2-dev, libxkbcommon-x11-dev, libxkbfile-dev.
  * Delete some useless documentation from the installation.

 -- Mattia Rizzolo <mattia@debian.org>  Sun, 16 Mar 2025 17:30:01 +0100

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,28 @@
 Source: sigil
 Section: editors
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Mattia Rizzolo <mattia@debian.org>
-Build-Depends: cmake,
-               debhelper-compat (= 13),
-               dh-sequence-python3,
-               libhunspell-dev,
-               libjs-jquery,
-               libjs-jquery-scrollto,
-               libminizip-dev,
-               libpcre2-dev,
-               pkg-config,
-               python3-dev,
-               qt6-base-dev,
-               qt6-svg-dev,
-               qt6-tools-dev,
-               qt6-webengine-dev,
-               zlib1g-dev
-Standards-Version: 4.7.0
+Maintainer: Mattia Rizzolo <mattia@debian.org>
+Build-Depends:
+ debhelper-compat (= 13),
+ dh-sequence-python3,
+ cmake,
+ libcups2-dev,
+ libhunspell-dev,
+ libjs-jquery,
+ libjs-jquery-scrollto,
+ libminizip-dev,
+ libpcre2-dev,
+ libxkbcommon-x11-dev,
+ libxkbfile-dev,
+ pkgconf,
+ python3-dev,
+ qt6-5compat-dev,
+ qt6-base-dev,
+ qt6-svg-dev,
+ qt6-tools-dev,
+ qt6-webengine-dev,
+ zlib1g-dev,
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://sigil-ebook.com
 Vcs-Git: https://salsa.debian.org/debian/sigil.git
@@ -26,27 +30,29 @@
 
 Package: sigil
 Architecture: any
-Depends: libhunspell-dev,
-         libjs-jquery-scrollto,
-         python3-dulwich,
-         python3-lxml,
-         sigil-data (<< ${source:Version}+),
-         sigil-data (>= ${source:Version}),
-         ${misc:Depends},
-         ${python3:Depends},
-         ${shlibs:Depends},
-         python3-six,
-            python3,
-            python3-chardet,
-            python3-css-parser,
-            python3-cssselect,
-            python3-cssutils,
-            python3-html5lib,
-            python3-pil,
-            python3-pyqt6,
-#            python3-pyqtwebengine,
-            python3-regex
-Suggests: pageedit
+Depends:
+ libhunspell-dev,
+ libjs-jquery-scrollto,
+ python3-dulwich,
+ python3-lxml,
+ sigil-data (<< ${source:Version}+),
+ sigil-data (>= ${source:Version}),
+ ${misc:Depends},
+ ${python3:Depends},
+ ${shlibs:Depends},
+Recommends:
+ python3,
+ python3-chardet,
+ python3-css-parser,
+ python3-cssselect,
+ python3-cssutils,
+ python3-html5lib,
+ python3-pil,
+ python3-pyqt5,
+ python3-pyqtwebengine,
+ python3-regex,
+Suggests:
+ pageedit,
 Description: multi-platform ebook editor
  Sigil is a free, open source, multi-platform ebook editor.
  It is designed to edit books in ePub format.
@@ -72,8 +78,10 @@
 Package: sigil-data
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}
-Recommends: sigil (= ${source:Version})
+Depends:
+ ${misc:Depends},
+Recommends:
+ sigil (= ${source:Version}),
 Description: multi-platform ebook editor - data files
  Sigil is a free, open source, multi-platform ebook editor.
  It is designed to edit books in ePub format.
@@ -96,4 +104,4 @@
   * HTML Tidy: all imported files have their formatting corrected, and your
     editing can be optionally cleaned.
  .
- This package provides the architecture-independent files.
+ This package provides the architecture-independant files.

=== debian/rules ===
--- 
+++ 
@@ -17,12 +17,12 @@
 		-DINSTALL_HICOLOR_ICONS=1 \
 
 execute_before_dh_install:
+	# these are all "documentation" that is useless for the user, or already available (i.e. d/copyright)
 	rm -v $(CURDIR)/debian/tmp/usr/share/sigil/plugin_launchers/python/sigil_bs4/COPYING.txt
+	rm -v $(CURDIR)/debian/tmp/usr/share/sigil/python3lib/unidecode/LICENSE
+	rm -v $(CURDIR)/debian/tmp/usr/share/sigil/python3lib/unidecode/README.rst
+	rm -v $(CURDIR)/debian/tmp/usr/share/sigil/plugin_launchers/python/sigil_bs4/AUTHORS.txt
+	rm -v $(CURDIR)/debian/tmp/usr/share/sigil/plugin_launchers/python/sigil_bs4/sigil_custom_changes_to_bs4-4.4.0.patch.txt
 
 override_dh_python3:
 	dh_python3 --no-ext-rename
-
-# No dbgsym packages:
-override_dh_strip:
-	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
-	dh_strip --no-automatic-dbgsym

=== debian/watch ===
version=4

opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\d+)?$//,\
pgpsigurlmangle=s|archive/(?:.*?/)([\d\.]+).tar\.gz|releases/download/$1/Sigil-$1.tar.gz.sig|,\
repacksuffix=+dfsg \
https://github.com/Sigil-Ebook/Sigil/tags (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
